/*
    ContactXfer - Transfer Contacts via Wireless Network

    Copyright (C) 2008  Nigel D. Stepp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Nigel Stepp <stepp@atistar.net>
    http://www.atistar.net/~stepp/contactxfer/

    $Id: NetworkConnection.h 282 2008-09-02 22:56:58Z stepp $
*/

#ifndef _NETWORKCONNECTION_H
#define _NETWORKCONNECTION_H

#import <sys/socket.h>
#import <netinet/in.h>
#import <UIKit/UIKit.h>
#import "TCPServer.h"

#define BUFFER_SIZE 4096

@interface NetworkConnection : NSObject <TCPServerDelegate> {
	id delegateObject;
	struct sockaddr *address;
	TCPServer *tcpServer;
	NSInputStream *inStream;
}

@property (nonatomic, retain) TCPServer *tcpServer;
@property (nonatomic, retain) id delegateObject;
@property (nonatomic, retain) NSInputStream *inStream;

-(BOOL) sendWithService:(NSNetService *)service data:(NSData *)sendData;
-(BOOL) startListenWithDelegate:(id)delegate;

-(void) didAcceptConnectionForServer:(TCPServer*)server inputStream:(NSInputStream *)istr outputStream:(NSOutputStream *)ostr;

- (void) stream:(NSStream*)stream handleEvent:(NSStreamEvent)eventCode;

@end

#endif
